Package: groovy.util

## [Java] Class ProxyGenerator

- groovy.util.ProxyGenerator

- Classes to generate 'Proxy' objects which implement interfaces, maps of closures and/or extend classes/delegates.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static ProxyGenerator` | `INSTANCE` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `boolean` | `getDebug()`
    `` | `boolean` | `getEmptyMethods()`
    `` | `ClassLoader` | `getOverride()`
    `` | `GroovyObject` | `instantiateAggregate(List<Class> interfaces)`
    `` | `GroovyObject` | `instantiateAggregate(Map closureMap, List<Class> interfaces)`
    `` | `GroovyObject` | `instantiateAggregate(Map closureMap, List<Class> interfaces, Class clazz)`
    `` | `GroovyObject` | `instantiateAggregate(Map closureMap, List<Class> interfaces, Class clazz, Object[] constructorArgs)`
    `` | `GroovyObject` | `instantiateAggregateFromBaseClass(Class clazz)`
    `` | `GroovyObject` | `instantiateAggregateFromBaseClass(Map map, Class clazz)`
    `` | `GroovyObject` | `instantiateAggregateFromBaseClass(Closure cl, Class clazz)`
    `` | `GroovyObject` | `instantiateAggregateFromBaseClass(Class clazz, Object[] constructorArgs)`
    `` | `GroovyObject` | `instantiateAggregateFromBaseClass(Map map, Class clazz, Object[] constructorArgs)`
    `` | `GroovyObject` | `instantiateAggregateFromInterface(Class clazz)`
    `` | `GroovyObject` | `instantiateAggregateFromInterface(Map map, Class clazz)`
    `` | `GroovyObject` | `instantiateDelegate(Object delegate)`
    `` | `GroovyObject` | `instantiateDelegate(List<Class> interfaces, Object delegate)`
    `` | `GroovyObject` | `instantiateDelegate(Map closureMap, List<Class> interfaces, Object delegate)`
    `` | `GroovyObject` | `instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate)`
    `` | `GroovyObject` | `instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate, Class baseClass)`
    `` | `GroovyObject` | `instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate, Class baseClass, String name)` Creates a proxy with a delegate object.
    `` | `Object` | `invokeStaticMethod(Object object, String methodName, Object[] arguments)`
    `` | `void` | `setDebug(boolean debug)` Instructs `ProxyGenerator` to dump generated Groovy source code to standard output during construction.
    `` | `void` | `setEmptyMethods(boolean emptyMethods)` Changes generated methods to have empty implementations.
    `` | `void` | `setOverride(ClassLoader override)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final ProxyGenerator INSTANCE

  - ### Method Detail

    - #### public boolean getDebug()

    - #### public boolean getEmptyMethods()

    - #### public ClassLoader getOverride()

    - #### public GroovyObject instantiateAggregate(List<Class> interfaces)

    - #### public GroovyObject instantiateAggregate(Map closureMap, List<Class> interfaces)

    - #### public GroovyObject instantiateAggregate(Map closureMap, List<Class> interfaces, Class clazz)

    - #### @com.github.javaparser.ast.expr.SingleMemberAnnotationExprSuppressWarnings public GroovyObject instantiateAggregate(Map closureMap, List<Class> interfaces, Class clazz, Object[] constructorArgs)

    - #### public GroovyObject instantiateAggregateFromBaseClass(Class clazz)

    - #### public GroovyObject instantiateAggregateFromBaseClass(Map map, Class clazz)

    - #### public GroovyObject instantiateAggregateFromBaseClass(Closure cl, Class clazz)

    - #### public GroovyObject instantiateAggregateFromBaseClass(Class clazz, Object[] constructorArgs)

    - #### public GroovyObject instantiateAggregateFromBaseClass(Map map, Class clazz, Object[] constructorArgs)

    - #### public GroovyObject instantiateAggregateFromInterface(Class clazz)

    - #### public GroovyObject instantiateAggregateFromInterface(Map map, Class clazz)

    - #### public GroovyObject instantiateDelegate(Object delegate)

    - #### public GroovyObject instantiateDelegate(List<Class> interfaces, Object delegate)

    - #### public GroovyObject instantiateDelegate(Map closureMap, List<Class> interfaces, Object delegate)

    - #### public GroovyObject instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate)

    - #### public GroovyObject instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate, Class baseClass)

    - #### @com.github.javaparser.ast.expr.SingleMemberAnnotationExprSuppressWarnings public GroovyObject instantiateDelegateWithBaseClass(Map closureMap, List<Class> interfaces, Object delegate, Class baseClass, String name)

      Creates a proxy with a delegate object.

      Parameters:
        `closureMap` - the closure for methods not handled by the delegate
        `interfaces` - interfaces to be implemented
        `delegate` - the delegate object
        `baseClass` - the base class
        `name` - the name of the proxy, unused, but kept for compatibility with previous versions of Groovy.
      Returns:
        a proxy object implementing the specified interfaces, and delegating to the provided object

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)

    - #### public void setDebug(boolean debug)

      Instructs `ProxyGenerator` to dump generated Groovy source code to standard output during construction. This is useful for debugging purposes but should be turned off in production.

      Parameters:
        `debug` - true if you want generated source to be printed

    - #### public void setEmptyMethods(boolean emptyMethods)

      Changes generated methods to have empty implementations.

      Methods in generated aggregates not supplied in a closures map or base class are given 'default' implementations. The implementation will normally throw an `UnsupportedOperationException` but setting this boolean will leave it empty.

      Parameters:
        `emptyMethods` - true if you want generated methods to be empty

    - #### public void setOverride(ClassLoader override)